DL_PrivateKeyImpl< GP > Class Template Reference

_ More...

`#include <pubkey.h>`

Inheritance diagram for DL_PrivateKeyImpl< GP >:

## Public Types

typedef GP::Element | Element
typedef GP | GroupParameters

## Public Member Functions

bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| check this object for errors More...
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| to be implemented by derived classes, users should use one of the above functions instead
void | AssignFrom (const NameValuePairs &source)
| assign values from source to this object More...
void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &params)
| generate a random key or crypto parameters More...
bool | SupportsPrecomputation () const
void | Precompute (unsigned int precomputationStorage=16)
| do precomputation More...
void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| retrieve previously saved precomputation
void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| save precomputation for later use
const DL_GroupParameters < Element > & | GetAbstractGroupParameters () const
DL_GroupParameters< Element > & | AccessAbstractGroupParameters ()
const Integer & | GetPrivateExponent () const
void | SetPrivateExponent (const Integer &x)
void | BERDecodePrivateKey (BufferedTransformation &bt, bool, size_t)
| decode privateKey part of privateKeyInfo, without the OCTET STRING header
void | DEREncodePrivateKey (BufferedTransformation &bt) const
| encode privateKey part of privateKeyInfo, without the OCTET STRING header
void | MakePublicKey (DL_PublicKey< GP::Element > &pub) const
OID | GetAlgorithmID () const
bool | BERDecodeAlgorithmParameters (BufferedTransformation &bt)
bool | DEREncodeAlgorithmParameters (BufferedTransformation &bt) const
const GP & | GetGroupParameters () const
GP & | AccessGroupParameters ()
void | BERDecode (BufferedTransformation &bt)
| decode this object from a BufferedTransformation, using BER (Basic Encoding Rules)
void | DEREncode (BufferedTransformation &bt) const
| encode this object into a BufferedTransformation, using DER (Distinguished Encoding Rules)
virtual void | BERDecodeOptionalAttributes (BufferedTransformation &bt)
| decode optional attributes including context-specific tag More...
virtual void | DEREncodeOptionalAttributes (BufferedTransformation &bt) const
| encode optional attributes including context-specific tag
void | Save (BufferedTransformation &bt) const
void | Load (BufferedTransformation &bt)
virtual void | BEREncode (BufferedTransformation &bt) const
| encode this object into a BufferedTransformation, using BER More...
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| calls the above function with a NameValuePairs object that just specifies "KeySize"
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| throws InvalidMaterial if this object fails Validate() test
void | DoQuickSanityCheck () const
template<class T >
bool | GetThisObject (T &object) const
| get a copy of this object or a subobject of it
template<class T >
bool | GetThisPointer (T *&p) const
| get a pointer to this object, as a pointer to T
template<class T >
bool | GetValue (const char *name, T &value) const
| get a named value, returns true if the name exists
template<class T >
T | GetValueWithDefault (const char *name, T defaultValue) const
| get a named value, returns the default if the name doesn't exist
std::string | GetValueNames () const
| get a list of value names that can be retrieved
bool | GetIntValue (const char *name, int &value) const
| get a named value with type int More...
int | GetIntValueWithDefault (const char *name, int defaultValue) const
| get a named value with type int, with default
template<class T >
void | GetRequiredParameter (const char *className, const char *name, T &value) const
void | GetRequiredIntParameter (const char *className, const char *name, int &value) const

## Static Public Member Functions

static void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| used by derived classes to check for type mismatch

## Protected Attributes

ByteQueue | m_optionalAttributes

## Detailed Description

### template<class GP>
class DL_PrivateKeyImpl< GP >

_

Definition at line 750 of file pubkey.h.

## Member Function Documentation

template<class GP>

bool DL_PrivateKeyImpl< GP >::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level
| ) |  | const

inline virtual

check this object for errors

Parameters

  level | denotes the level of thoroughness: 0 - using this object won't cause a crash or exception (rng is ignored) 1 - this object will probably function (encrypt, sign, etc.) correctly (but may not check for weak keys and such) 2 - make sure this object will function correctly, and do reasonable security checks 3 - do checks that may take a long time

Returns
  true if the tests pass

Implements CryptoMaterial.

Definition at line 756 of file pubkey.h.

template<class GP>

void DL_PrivateKeyImpl< GP >::AssignFrom | ( | const NameValuePairs & | source | ) |

inline virtual

assign values from source to this object

Note
  This function can be used to create a public key from a private key.

Implements CryptoMaterial.

Definition at line 774 of file pubkey.h.

template<class GP>

void DL_PrivateKeyImpl< GP >::GenerateRandom | ( | RandomNumberGenerator & | rng,
|  | const NameValuePairs & | params
| ) |  |

inline virtual

generate a random key or crypto parameters

Exceptions

  KeyingErr | if algorithm parameters are invalid, or if a key can't be generated (e.g., if this is a public key object)

Reimplemented from GeneratableCryptoMaterial.

Definition at line 779 of file pubkey.h.

template<class GP>

bool DL_PrivateKeyImpl< GP >::SupportsPrecomputation | ( |  | ) | const

inline virtual

Returns
  whether this object supports precomputation

Reimplemented from CryptoMaterial.

Definition at line 790 of file pubkey.h.

template<class GP>

void DL_PrivateKeyImpl< GP >::Precompute | ( | unsigned int | n = `16` | ) |

inline virtual

do precomputation

The exact semantics of Precompute() is varies, but typically it means calculate a table of n objects that can be used later to speed up computation.

Reimplemented from CryptoMaterial.

Definition at line 792 of file pubkey.h.

virtual void PKCS8PrivateKey::BERDecodeOptionalAttributes | ( | BufferedTransformation & | bt | ) |

virtual inherited

decode optional attributes including context-specific tag

/note default implementation stores attributes to be output in DEREncodeOptionalAttributes

virtual void ASN1Object::BEREncode | ( | BufferedTransformation & | bt | ) | const

inline virtual inherited

encode this object into a BufferedTransformation, using BER

this may be useful if DEREncode() would be too inefficient

Definition at line 1643 of file cryptlib.h.

bool NameValuePairs::GetIntValue | ( | const char * | name,
|  | int & | value
| ) |  | const

inline inherited

get a named value with type int

used to ensure we don't accidentally try to get an unsigned int or some other type when we mean int (which is the most common case)

Definition at line 281 of file cryptlib.h.

The documentation for this class was generated from the following file:

- pubkey.h